#include <iostream.h>

class Account {
public:
	Account();
	static void prelude();		// Initialise static
	float account_balance(void) const;// return the balance
	float withdraw( const float );	// withdraw from account
	void deposit( const float );	// deposit into account
	static void audit_trail();	// Simple audit trail
private:
	float   the_balance;		// The outstanding balance
	static int the_no_transactions;	// For audit trail
};

int Account::the_no_transactions;

void Account::prelude()
{
	the_no_transactions = 0;
}

Account::Account()
{
	the_balance = 0.0;
}

float Account::account_balance(void) const
{
	return the_balance;
}

float Account::withdraw( const float money )
{
	the_no_transactions++;
	if ( money <= the_balance )
	{
		the_balance = the_balance - money;
		return money;
	} else {
		return 0;
	}
}

void Account::deposit( const float money )
{
	the_balance = the_balance + money;
	the_no_transactions++;
}

void Account::audit_trail()
{
	cout << "The total number of transactions was ";
	cout << the_no_transactions;
	cout << "\n";
}

void main()
{
	Account mike;
	float obtained;

	Account::prelude();

	cout << "mike Balance = " << mike.account_balance() << "\n";

	mike.deposit(100);
	cout << "mike Balance = " << mike.account_balance() << "\n";

	obtained = mike.withdraw(20);
	cout << "mike has withdrawn " << obtained << "\n";
	cout << "mike Balance = " << mike.account_balance() << "\n";

	mike.deposit(50);
	cout << "mike Balance = " << mike.account_balance() << "\n";

	Account::audit_trail();
}
