#include <iostream.h>
#include <iomanip.h>

#include "s10_a.h"
#include "s10_ia.h"
#include "s35_addr.h"

class Named_Account : public Interest_Account, public Name_Address
{
public:
	Named_Account(const char name[] = "", const float = 0.0);
	void mini_statement() const;
};

Named_Account::Named_Account( const char name[], const float amount) :
	Name_Address(name) , Interest_Account()
{
	deposit( amount );
}

void Named_Account::mini_statement() const
{
	cout << "Mini Statement for ";
	print_name();
	cout << " Balance of account is  " << account_balance();
	cout << "\n";
}

void process(void);

void main()
{
	const double DAILY_RATE = 0.00026116;	// 10% Annual rate
	Named_Account::prelude(DAILY_RATE);

	cout << setiosflags( ios::showpoint );
	cout << setiosflags( ios::fixed );
	cout << setprecision(2);

	process();
}

void process()
{
	Named_Account   a_n_other( "A N Other/Brighton" );

	a_n_other.mini_statement();

	a_n_other.deposit(500);
	cout << "Deposit 500" << "\n";
	a_n_other.mini_statement();

	a_n_other.calc_interest();
	a_n_other.add_interest();
	cout << "Add interest at end of day" << "\n";
	a_n_other.mini_statement();
}
