#include <iostream.h>

const int MaxElements = 5;

enum Boolean { FALSE , TRUE };

class Stack {
public:
	Stack();
	Boolean push( const int );	// push item onto stack
	Boolean pop( int& );		// pop top item from stack
private:
	int     the_elements[MaxElements];	// Items in Stack
	int     the_tos;			// Top of Stack
};

Stack::Stack()
{
	the_tos = -1;
}


Boolean Stack::push( const int item )
{
	if ( the_tos < MaxElements-1 ) {
		the_elements[ ++the_tos ] = item;
		return TRUE;
	} else {
		return FALSE;
	}
}

Boolean Stack::pop( int& item )
{
	if ( the_tos < 0 ) {
		return FALSE;
	} else {
		item = the_elements[ the_tos-- ];
		return TRUE;
	}
}

void main()
{
	Stack numbers;
	char ch;


	while ( cin >> ch , !cin.eof() )
	{
		switch ( ch )
		{
			case '+' :	// push item onto stack
			{
				int num; cin >> num;
				if (numbers.push(num) == FALSE )
				{
					cout << "Stack Full" << "\n";
				}
				break;
			}
			case '-' : 	// pop item from stack
			{
				int num;
				if (numbers.pop(num) == FALSE )
				{
					cout << "Stack Empty" << "\n";
				} else {
					cout << "Num = " << num << "\n";
				}
				break;
			}
		}
	}
}
