#include <iostream.h>

enum Boolean { FALSE , TRUE };

const int MaxElements = 5;

template <class Type>
class Stack {
public:
	Stack();
	Boolean push( const Type );	// push item onto stack
	Boolean pop( Type& );		// pop top item from stack
private:
	Type    the_elements[MaxElements];	// Items in Stack
	int     the_tos;			// Top of Stack
};

template <class Type>
Stack<Type>::Stack()
{
	the_tos = -1;
}


template <class Type>
Boolean Stack<Type>::push( const Type item )
{
	if ( the_tos < MaxElements-1 ) {
		the_elements[ ++the_tos ] = item;
		return TRUE;
	} else {
		return FALSE;
	}
}

template <class Type>
Boolean Stack<Type>::pop( Type& item )
{
	if ( the_tos < 0 ) {
		return FALSE;
	} else {
		item = the_elements[ the_tos-- ];
		return TRUE;
	}
}

void main()
{
	Stack <float> numbers;	       // Stack of float
	char ch;

	while ( cin >> ch , !cin.eof() )
	{
		switch ( ch )
		{
			case '+' :	// push item onto stack
			{
				float num; cin >> num;
				if (numbers.push(num) == FALSE )
				{
					cout << "Stack Full" << "\n";
				}
				break;
			}
			case '-' :	// pop item from stack
			{
				float num;
				if (numbers.pop(num) == FALSE )
				{
					cout << "Stack Empty" << "\n";
				} else {
					cout << "Num = " << num << "\n";
				}
				break;
			}
		}
	}
}
