#include <iostream.h>

#include "s99_type.h"

class Element {
public:
	int the_value;		// Stored item
	Element *the_p_next;	// Pointer to next element
};

Element* const NIL = 0;

class Stack {
public:
	Stack();
	~Stack();
	Boolean push( const int );	// Push item on to stack
	Boolean pop( int& );		// Pop top item from stack
private:
	Element *the_p_tos;		// Pointer to first item
};


Stack::Stack()
{
	the_p_tos = NIL;
}

Stack::~Stack()
{
	int num;
	while ( pop(num) ) {}
}

Boolean Stack::push( const int item )
{
	Element *p_new_item = new Element[1];
	if ( p_new_item == NIL )
	{
		return FALSE;
	} else {
		p_new_item->the_value = item;
		p_new_item->the_p_next = the_p_tos;
		the_p_tos = p_new_item;
		return TRUE;
	}
}

Boolean Stack::pop( int& item )
{
	if ( the_p_tos ==  NIL ) {
		return FALSE;
	} else {
		Element *release = the_p_tos;
		item = the_p_tos->the_value;
		the_p_tos = the_p_tos->the_p_next;
		delete [] release;
		return TRUE;
	}
}

void main()
{
	Stack numbers;
	char ch;

	while ( cin >> ch , !cin.eof() )
	{
		switch ( ch )
		{
			case '+' :	// Push number onto stack
			{
				int num; cin >> num;
				if (numbers.push(num) == FALSE )
				{
					cout << "Stack Full" << "\n";
				}
				break;
			}
			case '-' :	// pop number from stack
			{
				int num;
				if (numbers.pop(num) == FALSE )
				{
					cout << "Stack Empty" << "\n";
				} else {
					cout << "Num = " << num << "\n";
				}
				break;
			}
		}
	}
}
