class Money {
public:
	Money( const int = 0, const int = 0 );	// Constructor
	Money operator + ( const Money );	// add operator
	Money operator ++();			// prefix increment
	Money operator ++(int);			// postfix increment
	void print(void);			// print
private:
	int     the_credits;		// In Units
	int     the_pence;		// In Pence
};

inline Money::Money( const int credits , const int pence )
{
	the_credits = credits; the_pence = pence;
}

void Money::print(void)
{
	cout << "#" << the_credits << "." << the_pence;
}

Money Money::operator + ( const Money p1 )
{
	Money res;
	res.the_pence  = p1.the_pence + the_pence;
	res.the_credits= res.the_pence / 100;
	res.the_pence  = res.the_pence % 100;
	res.the_credits= res.the_credits + p1.the_credits + the_credits;
	return res;
}

Money Money::operator ++ ()	// Prefix ++
{
	the_pence   = the_pence + 1;
	the_credits = the_credits + (the_pence / 100);
	the_pence   = the_pence % 100;
	return *this;
}

Money Money::operator ++ (int)	// Postfix ++
{
	Money res   = *this;
	the_pence   = the_pence + 1;
	the_credits = the_credits + (the_pence / 100);
	the_pence   = the_pence % 100;
	return res;
}
