class Money {
public:
	Money( const int = 0, const int = 0 );
	void print(void);			// print
	friend Money operator + ( const Money, const Money );
	friend Money operator ++( Money& );	// prefix increment
	friend Money operator ++( Money&, int );// postfix increment
private:
	int     the_credits;		// In Units
	int     the_pence;		// In Pence
};

inline Money::Money( const int credits, const int pence)
{
	the_credits = credits; the_pence = pence;
}

void Money::print(void)
{
	cout << "#" << the_credits << "." << the_pence;
}

Money operator + ( const Money p1, const Money p2 )
{
	Money res;
	res.the_pence  = p1.the_pence + p2.the_pence;
	res.the_credits= res.the_pence / 100;
	res.the_pence  = res.the_pence % 100;
	res.the_credits= res.the_credits + p1.the_credits + p2.the_credits;
	return res;
}

Money operator ++ ( Money& p1 )	// prefix ++
{
	p1.the_pence  = p1.the_pence + 1;
	p1.the_credits= p1.the_credits + (p1.the_pence / 100);
	p1.the_pence  = p1.the_pence % 100;
	return p1;
}

Money operator ++ ( Money& p1, int)	// Postfix
{
	Money res = p1;
	p1.the_pence  = p1.the_pence + 1;
	p1.the_credits= p1.the_credits + (p1.the_pence / 100);
	p1.the_pence  = p1.the_pence % 100;
	return res;
}
