class Money {
public:
	Money( const int = 0, const int = 0 );
	friend Money operator + ( const Money, const Money );
	friend Money operator ++ ( Money& );	// prefix increment
	friend Money operator ++ ( Money&, int );// postfix increment
	friend ostream& operator << ( ostream& s, const Money m );
//protected: // Still think this is a bug [ m.units() in call of const.]
	int units() const;	// return the units
	int hundredths() const;	// return the hundredths
private:
	int the_credits;	// In Units
	int the_pence;		// In Pence
};

Money::Money( const int credits, const int pence )
{
	the_credits = credits; the_pence = pence;
}

Money operator + ( const Money p1, const Money p2 )
{
	Money res;
	res.the_pence  = p1.the_pence + p2.the_pence;
	res.the_credits= res.the_pence / 100;
	res.the_pence  = res.the_pence % 100;
	res.the_credits= res.the_credits + p1.the_credits + p2.the_credits;
	return res;
}

Money operator ++ ( Money& p1 )	// Prefix
{
	p1.the_pence  = p1.the_pence + 1;
	p1.the_credits= p1.the_credits + (p1.the_pence / 100);
	p1.the_pence  = p1.the_pence % 100;
	return p1;
}

Money operator ++ ( Money& p1, int )	// Postfix
{
	Money res = p1;
	p1.the_pence  = p1.the_pence + 1;
	p1.the_credits= p1.the_credits + (p1.the_pence / 100);
	p1.the_pence  = p1.the_pence % 100;
	return res;
}

ostream& operator << ( ostream& s , const Money m )
{
	s << "#" << m.the_credits << "." << m.the_pence;
	return s;
}

inline int Money::units() const
{
	return the_credits;
}

inline int Money::hundredths() const
{
	return the_pence;
}
