class ECU : public Money {
public:
	ECU( int ecu = 0, int cents=0);
	friend ostream& operator << ( ostream& s , ECU m );
};

ECU::ECU( int ecu, int cents ) : Money( ecu, cents )
{
}

ostream& operator << ( ostream& s , ECU m )
{
	s << "ECU " << m.units() << "." << m.hundredths();
	return s;
}

class Francs : public Money {
public:
	Francs( int francs = 0, int centime=0);
	friend ostream& operator << ( ostream& s , Francs m );
};

Francs::Francs(int francs, int centime) : Money( francs, centime )
{
}

ostream& operator << ( ostream& s , Francs m )
{
	s << "Francs " << m.units() << "." << m.hundredths();
	return s;
}

class Pounds : public Money {
public:
	Pounds( Money );
	Pounds( const int = 0, const int = 0 );
	static void prelude( const double, const double );
	friend ostream& operator << ( ostream&, Pounds );
	operator ECU() const;		// Conversion operator ECU
	operator Francs() const;	// Conversion operator Francs
	operator Money() const;		// Conversion operator Money
private:
	static double the_ecu_rate;	// ECU rate
	static double the_franc_rate;	// Franc rate
	int	the_value;
};


double Pounds::the_ecu_rate = 1.0;
double Pounds::the_franc_rate = 1.0;


Pounds::Pounds( Money m ) : Money ( m.units(), m.hundredths() )
{
	// Needed as operators from the
	//  class money will deliver Money
}

Pounds::Pounds( const int pounds, const int pence) :
	 Money( pounds, pence )
{
}

void Pounds::prelude( const double ecu_rate, const double franc_rate )
{
	the_ecu_rate = ecu_rate;
	the_franc_rate = franc_rate;
}

ostream& operator << ( ostream& s, Pounds m )
{
	s << "" << m.units() << "." << m.hundredths();
	return s;
}

Pounds::operator ECU() const
{
	int cents = (int)floor( the_ecu_rate * hundredths() )
		    + (int) floor( the_ecu_rate * units() * 100 );
	int ecu   = cents / 100;
	cents = cents % 100;
	return ECU( ecu, cents );
}

Pounds::operator Francs() const
{
	int centime = (int) floor( the_franc_rate * hundredths() )
		    + (int) floor( the_franc_rate * units() * 100 );
	int francs = centime / 100;
	centime = centime % 100;
	return Francs( francs, centime );
}

Pounds::operator Money() const
{
	return Money( units(), hundredths() );
}
