#include <iostream.h>
#include <generic.h>
#include <stdlib.h>
#include "s99_type.h"

#define	DECLARE( Object, Type ) Object(Type)
#define	INSTANTIATE( Object, Type ) Object##_##Type

#define Safe_vec(Type)   					\
class Safe_vec_##Type {  					\
public:  							\
	Safe_vec_##Type(const int = 10); 			\
	~Safe_vec_##Type();      				\
	Type& operator()(const int);     			\
protected:       						\
	void fail( const char mes[], const int i ) const;	\
private: 							\
	Type *the_p_item;					\
	int  the_vec_size;       				\
};       							\
 								\
Safe_vec_##Type::Safe_vec_##Type( const int s )  		\
{								\
	if ( s < 0 ) fail( "Invalid size -" , s );    		\
	else the_vec_size = s;					\
	the_p_item = new Type[the_vec_size];     		\
	if ( the_p_item == (Type *) 0 ) {			\
		 fail("Cannot create vector - size",      	\
		       the_vec_size );    			\
	}							\
}								\
 								\
Safe_vec_##Type::~Safe_vec_##Type()      			\
{								\
	delete [] the_p_item;    				\
}								\
 								\
Type& Safe_vec_##Type::operator()( const int i ) 		\
{								\
	if ( i < 0 || i >= the_vec_size ) {      		\
		 fail( "Subscript error - subscript " , i );	\
	}							\
	return the_p_item[i];    				\
}								\
								\
void Safe_vec_##Type::fail(const char mes[], const int i ) const\
{								\
	cout << "\n" << "Error in class : Safe_vec" << "\n";	\
	cout << mes << " " << i << "\n"; exit(-1);		\
}								\

DECLARE( Safe_vec, int )
DECLARE( Safe_vec, char )

void main()
{
	INSTANTIATE(Safe_vec,int)      table(20);
	INSTANTIATE(Safe_vec,char)     string(26);
	int i;

	for(i=0; i<20; i++) table(i) = i;
	for(i=0; i<26; i++) string(i) = (char) ( (int) 'a'+i );
	for(i=5; i<10; i++) cout << table(i) << " ";
	cout << "\n";

	for(i=5; i<10; i++) cout << string(i) << " ";
	cout << "\n";

	cout << "Now accessing element 100";
	cout << string(100) << "\n";
}
