class Abstract_Account {
public:
	virtual T_Money account_balance(void) const = 0;// balance
	virtual T_Money withdraw( const T_Money ) = 0;// Withdraw
	virtual void deposit( const T_Money ) = 0;// Deposit
	virtual void type_of_account(void) const = 0;// Account is
	virtual void add_interest(void) = 0;	// At end of period
	virtual void calc_interest(void) = 0;	// This day
	virtual void print_details(void) const = 0;	// statement summary
	virtual ~Abstract_Account() {};
protected:
	virtual void accumulate_interest(const T_Money) = 0;
};

class N_Account : public Abstract_Account {
public:
	N_Account( const T_Money = 0.0 );
	~N_Account();
	void static prelude( void );
	T_Money account_balance(void) const;// balance
	T_Money withdraw( const T_Money );// Withdraw
	void deposit( const T_Money );	// Deposit
	void type_of_account(void) const;// Account type
	void add_interest(void);	// Nil action
	void calc_interest(void);	// Nil action
	void print_details(void) const;	// summary
protected:
	void accumulate_interest(const T_Money);// Nil action
private:
	T_Money   the_balance;		// The account balance
};

N_Account::N_Account(const T_Money m)
{
	the_balance = m;
}

void N_Account::prelude(void)
{
}

T_Money N_Account::account_balance(void) const
{
	return the_balance;
}

T_Money N_Account::withdraw( const T_Money money )
{
	if ( money <= the_balance )
	{
		the_balance = the_balance - money;
		return money;
	} else {
		return 0;
	}
}

void N_Account::deposit( const T_Money money )
{
	the_balance = the_balance + money;
}


void N_Account::type_of_account(void) const
{
	cout << "Normal Account";
}

void N_Account::add_interest(void) {}

void N_Account::accumulate_interest(const T_Money) {}

void N_Account::calc_interest(void) {}

void N_Account::print_details(void) const
{
	cout << setprecision(2);
	cout << setiosflags( ios::showpoint );
	cout << setiosflags( ios::fixed );
	cout << "Balance of account is " << account_balance();
}

N_Account::~N_Account()
{
	if ( account_balance() > 0.0 )
	{
		cout << setprecision(2);
		cout << "Warning Account not empty contains ";
		cout << account_balance();
		cout << "\n";
	}
}

class  I_Account : public N_Account {
public:
	I_Account(const T_Money = 0.0 );
	~I_Account();
	static void prelude( const double );
	void type_of_account(void) const;// type of account
	void add_interest(void);	// Add interest
	void calc_interest(void);	// calc interest
	void print_details(void) const;	// Summary of account
protected:
	void accumulate_interest(const T_Money);
private:
	static double the_rate;		// The interest rate this account
	T_Money the_accumulated_interest;// Interest gained
};

const T_Money DAILY_RATE = 0.00026116;	// 10% Annual rate

T_Money I_Account::the_rate;		// Declare the storage

I_Account::I_Account(const T_Money amount) : N_Account(amount)
{
	the_accumulated_interest = 0.0;
}

void I_Account::prelude(const T_Money rate)
{
	the_rate = rate;
}

void I_Account::type_of_account(void) const
{
	cout << "Interest Account";
}

void I_Account::calc_interest(void)
{
	accumulate_interest( account_balance() * the_rate );
}

void I_Account::accumulate_interest( const T_Money ia )
{
	the_accumulated_interest += ia;
}

void I_Account::add_interest(void)
{
	deposit( the_accumulated_interest );
	the_accumulated_interest = 0.0;
}

void I_Account::print_details(void) const 
{
	cout << setprecision(6);
	cout << "[DIR = ";
	cout << the_rate*100.0 << "%]" << "\n";
	N_Account::print_details();
}

I_Account::~I_Account()
{
	I_Account::add_interest();
}


class  S_Account : public I_Account {
public:
	S_Account(const T_Money = 0.0 );
	~S_Account();
	static void prelude(const double, const double, const double );
	void type_of_account(void) const;// Type of account
	void calc_interest(void);	// Calculate interest today
	void print_details(void) const;	// Summary of account
private:
	static double the_interest_rate1;	// Interest Rate 1
	static double the_interest_rate2;	// Interest Rate 2
	static double the_interest_rate3;	// Interest Rate 3
};


const T_Money DAILY_RATE_R1 = 0.00026116;	// 10% Annual rate
const T_Money DAILY_RATE_R2 = 0.00028596;	// 11% Annual rate
const T_Money DAILY_RATE_R3 = 0.00031054;	// 12% Annual rate

T_Money S_Account::the_interest_rate1;		// Interest Rate 1
T_Money S_Account::the_interest_rate2;		// Interest Rate 2
T_Money S_Account::the_interest_rate3;		// Interest Rate 3


S_Account::S_Account(const T_Money amount) : I_Account(amount)
{
}

void S_Account::prelude(
	const double r1=DAILY_RATE_R1, const double r2=DAILY_RATE_R2,
	const double r3=DAILY_RATE_R3 )
{
	the_interest_rate1 = r1;
	the_interest_rate2 = r2;
	the_interest_rate3 = r3;
}

void  S_Account::type_of_account(void) const
{
	cout << "Special Interest Account";
}

void S_Account::calc_interest(void)
{
	T_Money money =  account_balance();
	if ( money < 10000 )
		accumulate_interest( money*the_interest_rate1 );
	else if ( money < 25000 )
		accumulate_interest( money*the_interest_rate2 );
	else
		accumulate_interest( money*the_interest_rate3 );
}

void S_Account::print_details(void) const
{
	cout << setprecision(6);
	cout << "[DIR 25000+ = ";
	cout << the_interest_rate3*100.0 << "%]";
	cout << "[DIR 10000+ = ";
	cout << the_interest_rate2*100.0 << "%]";
	I_Account::print_details();
}

S_Account::~S_Account()
{
	S_Account::add_interest();
}
