
template <class Type>
class Safe_vec {
public:
	Safe_vec(const int = 10);
	~Safe_vec();
	Type& operator()(const int) const;	// Access with checking
	Type& operator[](const int) const;	// Access with checking
	Type& fast( const int i ) const;	// Fast access no checking
protected:
	void fail( const char mes[], const int i ) const;
private:
	Type *the_p_item;	// Pointer to array of Types
	int  the_vec_size;	// Size of array
};

template <class Type>
Type& Safe_vec <Type>::fast( const int i ) const
{
	return the_p_item[i];
}

template <class Type>
Safe_vec <Type>::Safe_vec( const int s )
{
	if ( s < 1 ) {
		fail( "Invalid size -" , s );
	} else {
		the_vec_size = s;
	}
	the_p_item = new Type[the_vec_size];
	if ( the_p_item == (Type *) 0 )
	{
		fail("Cannot create vector - size" , the_vec_size );
	}
}

template <class Type>
Safe_vec <Type>::~Safe_vec()
{
	delete [] the_p_item;
}

template <class Type>
Type& Safe_vec <Type>::operator()( const int i ) const
{
	if ( i < 0 || i >= the_vec_size ) {
		fail( "Subscript error - subscript " , i );
	}
	return the_p_item[i];
}

template <class Type>
Type& Safe_vec <Type>::operator[](const int i) const
{
	if ( i < 0 || i >= the_vec_size ) {
		fail( "Subscript error - subscript " , i );
	}
	return the_p_item[i];
}

template <class Type>
void Safe_vec <Type>::fail(const char mes[], const int i ) const
{
	cout << "\n" << "Error in class : Safe_vec" << "\n";
	cout << mes << " " << i << "\n";
	exit(-1);
}

