	
template <class Type>
struct Cell {
	char    *p_label;	// String used as label
	Type    value;		// stored item
	Cell    *p_next;	// next item in list
};


template <class Type>
class String_vec {
public:
	String_vec(int=5);
	~String_vec();
	void list(void);
	Type& operator()( const char* );// Access element
protected:
	int hash( const char * ) const;	// hash string to number
	void fail( const char mes[], const int ) const;
private:

	Cell <Type> **the_p_cell_vec;	// Pointer to a P_Cell
	int     the_no_elements;	// Number of elements

};


template <class Type>
String_vec<Type>::String_vec(int size)
{
	register int i;
	the_no_elements = size;
	if ( the_no_elements < 1 )
		fail("Invalid bounds - " , the_no_elements );

	the_p_cell_vec = new Cell <Type> *[the_no_elements];

	if ( the_p_cell_vec == (Cell <Type> **) 0 )
		fail("Cannot create - size " , size );

	for( i=0; i<the_no_elements; i++ )
		the_p_cell_vec[i]=((Cell <Type> *) 0);
}

template <class Type>
String_vec<Type>::~String_vec()
{
	int i;
	for( i=0; i< the_no_elements; i++)
	{
		Cell <Type> *p_cell = the_p_cell_vec[i];
		while ( p_cell != ((Cell <Type> *) 0) )
		{
			Cell <Type> * p_previous = p_cell;
			delete [] p_cell->p_label;	// Label
			p_cell = p_cell->p_next;
			delete [] p_previous;		// Storage
		}
	}
	delete [] the_p_cell_vec;
}

template <class Type>
int String_vec<Type>::hash( const char *s ) const
{
	register int h=0;
	while ( *s != 0 )
	{
		h = h + (int) *s++;
	}
	return h % the_no_elements;
}

template <class Type>
Type& String_vec<Type>::operator()( const char *s )
{
	register int h = hash( s );
	register Cell <Type> **p = &the_p_cell_vec[h];

	while ( *p != ((Cell <Type> *) 0) ) {
		if ( strcmp( (*p)->p_label , s ) == 0 ) {
			return (*p)->value;
		}
		p = &((*p)->p_next);
	}

	// Non existing element create & chain in

	*p = new Cell <Type> [1];
	if ( *p == (Cell <Type> *) 0 )
		fail("Cannot allocate storage : chain -" , h );

	(*p)->p_label = new char[strlen(s)+1];
	strcpy( (*p)->p_label , s );
	(*p)->p_next  = ((Cell <Type> *) 0);
	return (*p)->value;
}

template <class Type>
void String_vec<Type>::list(void)
{
	register int h = 0;
	while ( h < the_no_elements ) {
		register Cell <Type> **p = &the_p_cell_vec[h];
		cout << "C " << h << "\t: ";
		while ( *p != ((Cell <Type> *) 0) ) {
			cout << (*p)->p_label << " ";
			cout << (*p)->value << " ";
			p = &((*p)->p_next);
		}
		cout << "\n"; h++;
	}
}

template <class Type>
void String_vec<Type>::fail(const char mes[], const int i ) const
{
	cout << "\n" << "Error in class : String_vec" << "\n";
	cout << mes << " " << i << "\n";
	exit(-1);
}
