#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#define inline

int trace_it = 1;

class Trace {
public:
	Trace( const char the_mes[], int p1=0, int p2=0);
	~Trace();
private:
	char the_mes[100];	// Trace Message
	static int the_level;	// Depth
};

int Trace::the_level = 0;

Trace::Trace( const char text[] , int p1 , int p2 )
{
	char tmp[ 120 ];
	if ( !trace_it ) return;
	sprintf( tmp , text , p1 , p2 );
	strcpy( the_mes , tmp ); the_level++;
	for( int i=0; i <= the_level; i++) cout << "  ";
	cout << ">> " << the_mes << "\n";
}

Trace::~Trace()
{
	for( int i=0; i <= the_level; i++) cout << "  ";
	cout << "<< " << the_mes << "\n";
	the_level--;
	if ( the_level < 0 )
	{
		cout << "Below 0 " << "\n"; the_level = 0;
	}
}


class Number {
public:
	Number();			// Constructors
	Number(const int);
	~Number();			// Destructor
	Number(const Number& copy);	// Copy constructor
	Number& operator = ( const Number& ); // Shallow copy
	Number& operator <<= ( const Number& );// Deep copy
	friend Number operator + ( const Number& , const Number& );
	friend ostream& operator << ( ostream& , const Number& );
	int value(void) const { return the_p_desc->p_item[0]; }; // DEBUG
protected:
	void fail( const char[] ) const;// Give up
	void release_storage();		// Return storage for item
	void build_storage(const int);	// Create storage for item
private:
	struct Desc_Number { int *p_item; int references; };
	Desc_Number *the_p_desc;	// Pointer to descriptor for number
};

inline Number::Number()
{
	Trace X("Constructor integer(0)");
	build_storage(0);
}

inline Number::Number(const int value)
{
	Trace X("Constructor integer(%d)", value);
	build_storage(value);
}

inline Number::~Number()
{
	Trace X("Destructor ~integer(%d)",this->value() );
	this->release_storage();
}

inline Number::Number(const Number& copy)
{
	Trace X("Number(Number& %d)", copy.value()) ;
	the_p_desc = copy.the_p_desc;	// Copy pointer to descriptor
	(the_p_desc->references)++;	// Increment references
}


void Number::fail( const char the_mes[] ) const
{
	cout << "\n" << "Error in class : Number" << "\n";
	cout << the_mes << "\n";
	exit(-1);
}

void Number::build_storage(const int value)
{
	the_p_desc = new Desc_Number[1];
	if ( the_p_desc == (Desc_Number*) 0 )
		fail("Cannot create Number - descriptor");

	the_p_desc->p_item = new int[1];
	if ( the_p_desc->p_item == (int*) 0 )
		fail("Cannot create Number - storage");

	the_p_desc->p_item[0] = value;
	the_p_desc->references = 1;
}

void Number::release_storage()
{
	if ( --(the_p_desc->references) == 0 ) {
		Trace X("Release storage for [%d]", this->value() );
		delete [] the_p_desc->p_item;	// The item
		delete [] the_p_desc;		// its descriptor
	}
}

Number& Number::operator = ( const Number& from )
{
	Trace X("operator = ( Number& %d) " , from.value() );
	(from.the_p_desc->references)++;	// Number copied

	this->release_storage();		// Overwritten Number

	the_p_desc = from.the_p_desc;		// Perform the copy
	return *this;
}

Number& Number::operator <<= ( const Number& from )
{
	Trace X("operator <<= (Number& %d) ", from.value() );
	Number copy = from.the_p_desc->p_item[0];  // new Number
	(copy.the_p_desc->references)++;// Two users
	release_storage();		// Assigned too
	the_p_desc = copy.the_p_desc;   // new copy
	return *this;			// result of assignment
}


Number operator + ( const Number& num1, const Number& num2 )
{
	Trace X("operator %d + %d", num1.value(), num2.value() );
	Number result =
		num1.the_p_desc->p_item[0] +
		num2.the_p_desc->p_item[0];	// Construct result
	return result;
}

ostream& operator << ( ostream& s, const Number& num1 )
{
	int result;
	result = num1.the_p_desc->p_item[0];
	s << result;
	return s;
}

void main1(); void main2(); void main3(); void main4();

void main()
{
	main2();
	main1();
	main3();
	main4();
}

void main1()
{
	Number int_1(10),int_2(20);
	cout << "int_1 = int_2" << "\n";
	int_1 = int_2;
	cout << "Int_1 = " << int_1 << " Int_2 = " << int_2 << "\n";

}

void main2()
{
	Number total_fruit = 0, apples = 20, pears = 30;

	cout << "total_fruit = apples + pears" << "\n";
	total_fruit = apples + pears;
	cout << "total_fruit = " << total_fruit;
	cout << " apples = " << apples;
	cout << " pears = " << pears << "\n";
}

void main3()
{
	Number int_1(10),int_2(20),int_3(30),int_4(40);

	cout << "int_4 = int_1" << "\n";
	int_4 = int_2;

	cout << "int_1 = int_2 + int_3" << "\n";
	int_1 = int_2 + int_3;

	cout << "cout << Number(7); " << "\n";
	cout << Number(7) << "\n";

	cout << "int_1 = Number(1) + Number(2) " << "\n";
	int_1 = Number(1) + Number(2);
	cout << "Answer = " << int_1 << "\n";
}

void main4()
{
	Number paper,a4,a3,red_a3,blue_a4;
	a4 = 400;
	a3 = 500;
	red_a3 = a3;		// Shallow copy
	red_a3 <<= a3;		// Deep copy
	blue_a4 <<= a4;		// Deep copy
	paper = a3 + a4;	// Shallow copy of a3+a4
	paper <<= a3 + a4;	// Deep copy of a3+a4
}

