-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

--(class_description.ADS) Implementation Instantiation

--
-- Split the components of a CGI result string into
--  individual sub strings
--
-- For example the string
--   name=Your+name&action=%2B10%25&log=~mas/log
--
-- is composed of three named elements:
--
--     Element    String associated with element
--     name       Your name
--     action     +10%
--     log        /usr/staff/mas/log
--
-- (C) M.A.Smith University of Brighton
-- Permission is granted to use this code
--   provided this declaration and copyright notice remains intact.
-- 4 January 1996
--
--
--
-- S p e c i f i c a t i o n


with Simple_io, Ada.Strings.Unbounded; 
use  Simple_io, Ada.Strings.Unbounded;
package Class_parse is
  type Parse is private;
  procedure set( the:in out Parse; mes:in String );
  function  get_item( the:in Parse; key: in String; pos:in Integer:=1; 
                     map:in Boolean :=false ) return String;
private
  SEP : CONSTANT Character := '&';
  type Parse is record
    str : Unbounded_string;            -- String to parse
    len : Integer;                     -- Length
  end record;
end Class_parse;
