#!/bin/bash
cat <<++END++ > __split
#!/bin/bash
echo Processing file \$1
rm -f -r \$1
mkdir \$1
cp \$1.ada \$1/\$1.ada
cd \$1
gnatchop -w -s \$1.ada >& __list
rm -f -r \$1.sh
rm -f -r \$1.ada
cat <<+END+ > __banner
-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

+END+
for i in *.ad*
do
    cat __banner \$i > __tmp
    mv __tmp \$i
done
rm -f -r __tmp __banner
cat <<+END+ > files.htm
<HTML>

<HEAD>
  <TITLE>Object-oriented software in Ada 95: example program</TITLE>
  <LINK TITLE="Ada 95" HREF="mailto:M.A.Smith@brighton.ac.uk" >
  <META NAME="AUTHOR" CONTENT="Mike Smith">
</HEAD>

<BODY BACKGROUND="../../pic/backgrd.jpg">
<IMG SRC=../../pic/title.gif ALT="Object-Oriented Software in Ada95">
<BR>
<FONT SIZE=+2>
  The program
  <FONT COLOR=RED>
+END+
echo \$1.ada >> files.htm
cat <<+END+ >> files.htm
  </FONT>
  split into individual units
  </FONT>
  <BR>
  <P>
  <FONT SIZE=+3>F</FONT>iles:
    
<TABLE>
 <TD MARGIN=0>
   <IMG SRC="../../pic/book_s.gif" WIDTH=100 HEIGHT=130 ALT="book"></A>
 </TD>
 <TD>
    <UL>
+END+
cat <<+END+ > __sed
/splitting/d
/written/d
/^ *$/d
s/ //g
s/.*/<LI> <A HREF=\\\\"&\\\\"> & <\\\\/A>/
+END+
sed -f __sed < __list >> files.htm
rm -f -r __list __sed
ls *.ad* | sed -e "s/.*/<LI><A HREF=\\"&\\"> & <\\/A>/" >> /dev/null
cat <<+END+ >> files.htm
    </UL>

  </TD>
</TABLE>
<P>
Back to the list of <A HREF="../home_p.htm">[programs]</A> in the book
or to this <A HREF="../\$1.htm">[program]</A> as one unit.

<HR>
<FONT COLOR=#808080>
&#169; M.A.Smith University of Brighton.
Created September 1995 last modified May 1997.
<BR>
 <I>
  Comments, suggestions, etc. 
  <A HREF="mailto:M.A.Smith@brighton.ac.uk">
  M.A.Smith@brighton.ac.uk
  </A>
 </I>
 *
 <A HREF="http://www.brighton.ac.uk/ada95/home.htm" TARGET="_top">
 [Home page]</A>
</FONT>

</BODY>
</HTML>
+END+
++END++
chmod +x __split
cp simple_io.ads simple_io.ada
sh __split simple_io
rm -f -r simple_io.ada
sh __split cgi_pars
sh __split cgi_qs
sh __split x09_acc2
sh __split x11_acc3
sh __split x20_st_a
sh __split x21_ttt
sh __split x22_st_g
sh __split x35_rat
sh __split x40_st_g
sh __split x80_gam
sh __split x11_acc4
sh __split x11_acc5
sh __split x11_mlt
sh __split y11_pol1
sh __split x20_hist
sh __split x21_sor3
sh __split x36_str5
sh __split x56_tree
sh __split x60_ll5
sh __split x60_set
sh __split x61_rc_g
sh __split x70_cc1
sh __split x70_cc4
sh __split x72_t0
sh __split x72_t1
sh __split x72_t3
sh __split x72_tui
sh __split x80_arch
sh __split x80_ed
sh __split x80_exp
sh __split x99_mix
rm -f -r __split
