-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io, Class_account, Class_tui;
use  Simple_io, Class_account, Class_tui;
package body Class_container is

procedure main1 is
  miles  : Float;
  screen : TUI;
  function float_image( f:in Float ) return String is
    res : String( 1 .. 10 );        -- String of 10 characters
  begin
    put( res, f, aft=>2, exp=>0 );  -- 2 digits - NO exp
    return res;
  end float_image;
begin
  message( screen, "Distance converter" );
  dialog ( screen, "Enter distance in miles", miles );
  message( screen, "Distance in kilometers is " &
                    Float'Image( miles * 1.6093 )  );
  message( screen, "Distance in kilometers is " &
                    Float_image( miles * 1.6093 )  );
end main1;

procedure main2 is
  user     : Account;            -- The users account
  screen   : TUI;                -- The display screen
  cash     : Money;              --
  received : Money;              --

  function float_image( f:in Float ) return String is
    res : String( 1 .. 10 );     -- String of 10 characters
  begin
    put( res, f, 2, 0 );         -- 2 digits - NO exp
    return res;
  end float_image;

begin
  loop
    menu( screen, "Deposit", "Withdraw", "Balance", "" );
    case event( screen ) is
      when M_1 =>                                    -- Deposit
        dialog( screen, "Amount to deposit", cash );
        if cash <= 0.0 then
          message( screen, "Must be >= 0.00" );
        else
          deposit( user, cash );
        end if;
      when M_2 =>                                     -- Withdraw
        dialog( screen, "Amount to withdraw", cash );
        if cash <= 0.0 then
          message( screen, "Must be >= 0.00" );
        else
          withdraw( user, cash, received );
          if received <= 0.0 then
            message( screen, "Not enough money" );
          end if;
        end if;
      when M_3 =>                                    -- Balance
         message( screen, "Balance is " &
                            float_image( balance(user)) );
      when M_QUIT =>                                 -- Exit
         return;
      when others =>                                 -- Not used
          message( screen, "Program error");         -- oops
    end case;
  end loop;
end main2;

end Class_container;
