-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- ---- --- --- --- --- --- --- --- --- --- --- --- --- ---

-- FIX
-- type Abstract_account  is tagged private;
--  MUST BE 
-- type Abstract_account  is abstract tagged private;

package Class_abstract_account_other is

  type Abstract_account  is abstract tagged private;
  type Abstract_account2 is abstract tagged private;
  subtype Money  is Float;
  subtype PMoney is Float range 0.0 .. Float'Last;

  procedure statement( the:in Abstract_account ) is abstract;
  procedure deposit  ( the:in out Abstract_account;
                      amount:in PMoney ) is abstract;
  procedure withdraw ( the:in out Abstract_account;
                       amount:in PMoney;
                       get:out PMoney ) is abstract;
  function  balance  ( the:in Abstract_account )
                       return Money is abstract;
private
  type Abstract_account  is abstract tagged record null; end record;
  type Abstract_account2 is abstract tagged null record;
end Class_abstract_account_other;
