-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------



package body Pack_procedures is

procedure ex1 is
  mike  : Interest_account;
  obtain: Money;
begin
  statement( mike );
  withdraw( mike, 100.00, obtain ); -- Withdraw some money
  statement( mike );
  deposit( mike, 300.00 );          -- In credit
  statement( mike );
end ex1;

procedure ex2 is
  mike  : Account_ltd;
  obtain: Money;
begin
  deposit( mike, 300.00 );          -- In credit
  statement( mike );
  withdraw( mike, 100.00, obtain ); -- Withdraw some money
  withdraw( mike,  10.00, obtain ); -- Withdraw some money
  withdraw( mike,  10.00, obtain ); -- Withdraw some money
  withdraw( mike,  20.00, obtain ); -- Withdraw some money
  statement( mike );
end ex2;

procedure ex3 is
  mike  : Account_ltd;
  obtain: Money;
begin
  deposit( mike, 300.00 );          -- In credit
  statement( mike );
  withdraw( mike, 100.00, obtain ); -- Withdraw some money
  statement( mike );
  withdraw( mike,  10.00, obtain ); -- Withdraw some money
  statement( mike );
  withdraw( mike,  10.00, obtain ); -- Withdraw some money
  statement( mike );
  withdraw( Account(mike),  20.00, obtain ); -- Cheat
  statement( mike );
end ex3;

procedure ex4 is
  MAX_ACCOUNTS : CONSTANT := 5;
  type P_account is access all Account'Class;

  type    Bank_index is range 1 .. MAX_ACCOUNTS;
  subtype Bank_range is Bank_index;
  type    Bank_array is array ( Bank_range ) of P_account;

  procedure print_statement( no:in Bank_range;
                              a:in Account'Class ) is
  begin
    put("Account number #");
    put( Integer'Image(Integer(no)) ); new_line;
    statement( a );
  end print_statement;

  piggy    : Bank_array;
  obtained : Money;

begin
  piggy(1) := new Account;
  piggy(2) := new Account_ltd;
  piggy(3) := new Interest_account;
  piggy(4) := new Interest_account;
  piggy(5) := new Account;


  deposit( piggy(1).all, 100.00 );        -- deposit $100 #1
  deposit( piggy(3).all, 100.00 );        -- deposit $100 #3

  withdraw( piggy(2).all, 50.00, obtained ); -- withdraw $50 #2
  withdraw( piggy(4).all, 50.00, obtained ); -- withdraw $50 #4

  for i in Bank_range loop
    print_statement( i, piggy(i).all );
  end loop;
  null;
end ex4;

end Pack_procedures;
