-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- ---- --- --- --- --- --- --- --- --- --- --- --- --- ---

with Class_abstract_account;
use  Class_abstract_account;
package Class_account is

  type Account is new Abstract_account with private;
  subtype Money  is Class_abstract_account.Money;
  subtype PMoney is Class_abstract_account.PMoney;

  procedure statement( the:in Account );
  procedure deposit  ( the:in out Account; amount:in PMoney );
  procedure withdraw ( the:in out Account; amount:in PMoney;
                       get:out PMoney );
  function  balance  ( the:in Account ) return Money;
private
  type Account is new Abstract_account with record
    balance_of : Money := 0.00;       -- Amount in account
  end record;
end Class_account;
