-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- ---- --- --- --- --- --- --- --- --- --- --- --- --- ---

with Class_account;
use  Class_account;
package Class_interest_account is

  type Interest_account is new Account with private;

  procedure set_rate( rate:in Float );
  procedure calc_interest( the:in out Interest_account );
  procedure add_interest( the:in out Interest_account );
private
  DAILY_INTEREST_RATE: CONSTANT Float := 0.00026116; -- 10%
  type Interest_account is new Account with record
    accumulated_interest : Money := 0.00;            -- To date
  end record;
  the_interest_rate      : Float := DAILY_INTEREST_RATE;
end Class_interest_account;
