-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


package body Class_name_address is

  function spaces( line:in Positive ) return String;

  procedure set( the:out Name_address; str:in String ) is
  begin
    if str'Length > MAX_CHS then
      set( the, str( str'First .. str'First+MAX_CHS-1 ) );
    else
      the.text( 1 .. str'Length ) := str;
      the.length := str'Length;
    end if;
  end set;

--  The reason for the line:
--      for i in 1 .. Line_range(the.length) loop
--  is so the compiler will know that the index i can never go outside
--  the range of the array so no need to do array bound checking

  function deliver_line( the:in Name_address;
                         line:in Positive ) return String is
    line_on : Positive := 1;
  begin
    for i in 1 .. the.length loop
      if line_on = line then
        for j in i .. the.length loop
          if the.text(j) = '/' then
            return spaces(line_on) & the.text(i .. j-1);
          end if;
        end loop;
        return spaces(line_on) & the.text(i..the.length);
      end if;
      if the.text(i) = '/' then line_on := line_on+1; end if;
    end loop;
    return "";
  end deliver_line;

  function lines( the:in Name_address ) return Positive is
    no_lines : Positive := 1;
  begin
    for i in  1 .. the.length loop
      if the.text(i) = '/' then no_lines := no_lines + 1; end if;
    end loop;
    return no_lines;
  end lines;

  function spaces( line:in Positive ) return String is
    spaces_are : String( 1 .. Line ) := (others=>' ');
  begin
    return spaces_are;
  end spaces;

end Class_name_address;
