-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

package Class_name_address is
  type Name_address is tagged private;

  procedure set( the:out Name_address; str:in String );
  function deliver_line( the:in Name_address;
                         line:in Positive ) return String;
  function lines( the:in Name_address ) return Positive;
private
  MAX_CHS : CONSTANT := 200;
  subtype Line_index   is Natural    range 0 .. MAX_CHS;
  subtype Line_range   is Line_index range 1 .. MAX_CHS;

  type Name_address is tagged record
    text   : String( Line_range );   -- Details
    length : Line_index := 0;        -- Length of address
  end record;
end Class_name_address;
