-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- ---- --- --- --- --- --- --- --- --- --- --- --- --- ---

with Class_account, Class_name_address;
use  Class_account, Class_name_address;
package Class_named_account is

  type Named_account is tagged private;
  subtype PMoney is Class_account.PMoney;
  subtype Money  is Class_account.Money;

  procedure set( the:out Named_account; str:in String );
  function deliver_line( the:in Named_account;
                         line:in Positive ) return String;
  function lines( the:in Named_account ) return Positive;
  procedure statement( the:in Named_account );
  procedure deposit( the:in out Named_account; amount:in PMoney );
  procedure withdraw( the:in out Named_account; amount:in PMoney;
                      get:out PMoney );
  function  balance( the:in Named_account ) return PMoney;
private
  type Named_account is tagged record
    acc : Account;           -- An account object
    naa : Name_address;      -- A Name and address object
  end record;
end Class_named_account;
