-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

with Simple_io, Ada.Characters.Handling; 
use  Simple_io, Ada.Characters.Handling;
package Class_histogram is
  type Histogram is private;
  DEF_HEIGHT : CONSTANT Positive := 14;

  procedure reset( the:in out Histogram );
  procedure add_to( the:in out Histogram; a_ch:in Character );
  procedure put(the:in Histogram; height:in Positive:=DEF_HEIGHT);
private
  type    Alphabet_index is new Character range 'A' .. 'Z';
  subtype Alphabet_range is Alphabet_index;
  type    Alphabet_array is array (Alphabet_range) of Natural;

  type Histogram is record
    number_of   : Alphabet_array := ( others => 0 );
  end record;
end Class_histogram;
