-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------



package body Class_stack is

  procedure push( the:in out Stack; item:in Integer ) is
  begin
    if the.tos /= MAX_STACK then
      the.tos := the.tos + 1;               -- Next element
      the.elements( the.tos ) := item;      -- Move in
    else
      raise Stack_error;                    -- Failed
    end if;
  end push;

  procedure pop( the:in out Stack; item :out Integer ) is
  begin
    if the.tos > 0 then
      item := the.elements( the.tos );      -- Top element
      the.tos := the.tos - 1;               -- Move down
    else
      raise Stack_error;                    -- Failed
    end if;
  end pop;

  procedure reset( the:in out Stack ) is
  begin
    the.tos := 0;  -- Set TOS to 0 (Non existing element)
  end reset;

end Class_stack;
