-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

package Class_stack is
  type Stack is private;                -- Copying allowed
  Stack_error: exception;               -- When error

  procedure reset( the:in out Stack);
  procedure push( the:in out Stack; item:in Integer );
  procedure pop(the:in out Stack; item :out Integer );
private

  MAX_STACK: CONSTANT := 3;
  type    Stack_index is range 0 .. MAX_STACK;
  subtype Stack_range is Stack_index range 1 .. MAX_STACK;
  type    Stack_array is array ( Stack_range ) of Integer;

  type Stack is record
    elements: Stack_array;          -- Array of elements
    tos     : Stack_index := 0;     -- Index
  end record;

end Class_stack;
