-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------



with Simple_io, sort;
use  Simple_io;
procedure main3 is
  MAX_CHS : CONSTANT := 7;
  type Height_cm is range 0 .. 300;
  type Person is record
    name   : String( 1 .. MAX_CHS );  -- Name as a String
    height : Height_cm := 0;          -- Height in cm.
  end record;
  type People_range is (FIRST, SECOND, THIRD, forTH );
  type People       is array( People_range ) of Person; 

  function cmp_height(first, second:in Person) return Boolean is
  begin
    return first.height > second.height;
  end cmp_height;

  function cmp_name( first, second:in Person ) return Boolean is
  begin
    return first.name > second.name;
  end cmp_name;

  procedure sort_people_height is new sort (
    T         => Person,
    Vec_range => People_range,
    Vec       => People,
    ">"       => cmp_height );

  procedure sort_people_name is new sort (
    T         => Person,
    Vec_range => People_range,
    Vec       => People,
    ">"       => cmp_name );

  friends : People := ( ("Paul   ", 146 ), ("Carol  ", 147 ), 
                        ("Mike   ", 183 ), ("Corinna", 171 ) );
begin
  sort_people_name( friends );                    -- Name order
  put( "The first in ascending name order is   " );
  put( friends( FIRST ).name ); new_line;
  sort_people_height( friends );                  -- Height order
  put( "The first in ascending height order is " );
  put( friends( FIRST ).name ); new_line;
end main3;
