-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io; use Simple_io;
package body Class_board is

  procedure add( the:in out Board; pos:in Integer;
                 piece:in Character ) is
  begin
    the.sqrs( pos ) := piece;
  end add;

  function valid(the:in Board; pos:in Integer) return Boolean is
  begin
    return pos in Board_range and then the.sqrs( pos ) = ' ';
  end valid;

  procedure display( the:in Board ) is
  begin
    for i in Board_range loop          -- All pieces
      put( the.sqrs( i ) );            -- Display counter;
      case i is                        -- after printing counter
        when 3 | 6  =>                 --  print Row Separator
          new_line; put("---------");
          new_line;
        when 9      =>                 --  print new line
          new_line;
        when 1 | 2 | 4 | 5 | 7 | 8 =>  --  print Col separator
          put(" | ");
      end case;
    end loop;
  end display;
end Class_board;
