-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

with Text_io; use Text_io;

generic
  type Stack_element is private;  -- Can specify any type
  MAX_STACK:in Positive := 3;     -- Has to be typed / not const
package Class_stack is
  type Stack is private;
  Stack_error: exception;

  procedure reset( the:in out Stack);
  procedure push( the:in out Stack; item:in Stack_element );
  procedure pop( the:in out Stack; item:out Stack_element );
private

  type    Stack_index is new Integer range 0 .. MAX_STACK;
  subtype Stack_range is Stack_index
          range 1 .. Stack_index(MAX_STACK);
  type    Stack_array is array ( Stack_range ) of Stack_element;

  type Stack is record
    elements: Stack_array;          -- Array of elements
    tos     : Stack_index := 0;     -- Index
  end record;

end Class_stack;
