-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


package Class_rational is
  type Rational is private;

  function "+" ( f:in Rational; s:in Rational ) return Rational;
  function "-" ( f:in Rational; s:in Rational ) return Rational;
  function "*" ( f:in Rational; s:in Rational ) return Rational;
  function "/" ( f:in Rational; s:in Rational ) return Rational;

  function rat_const( f:in Integer;
                      s:in Integer:=1 ) return Rational;
  procedure put( the:in Rational );
private
  function sign( the:in Rational ) return Rational;
  function simplify( the:in Rational ) return Rational;
  type Rational is record
    above : Integer := 0;      -- Numerator
    below : Integer := 1;      -- Denominator
  end record;
end Class_rational;
