-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io, Class_rational;
use  Simple_io, Class_rational;
package body Pack_procedures is

procedure main1 is
  a,b : Rational;
begin
  a := rat_const( 1, 2 );
  b := rat_const( 1, 3 );

  put( "a     = " ); put( a );   new_line;
  put( "b     = " ); put( b );   new_line;
  put( "a + b = " ); put( a+b ); new_line;
  put( "a - b = " ); put( a-b ); new_line;
  put( "b - a = " ); put( b-a ); new_line;
  put( "a * b = " ); put( a*b ); new_line;
  put( "a / b = " ); put( a/b ); new_line;
end main1;

procedure main2 is
  a,b : Rational;
begin
  a := rat_const(1, 2);
  b := rat_const(1, 3);

  put( "a     = " ); put( a ); put(" <1/2> "); new_line;
  put( "b     = " ); put( b ); put("  <1/3> "); new_line;
  put( "a + b = " ); put( a+b ); put(" <5/6> "); new_line;
  put( "a - b = " ); put( a-b ); put(" <1/6> "); new_line;
  put( "b - a = " ); put( b-a ); put(" <-1/6> "); new_line;
  put( "a * b = " ); put( a*b ); put(" <1/6> "); new_line;
  put( "a / b = " ); put( a/b ); put(" <1 1/2> "); new_line;

  new_line;
  a := rat_const(3, 2);
  b := rat_const(4, 5);
  put( "a     = " ); put( a ); put(" <3/2> "); new_line;
  put( "b     = " ); put( b ); put(" <4/5> "); new_line;
  put( "a + b = " ); put( a+b ); put(" <2 3/10> "); new_line;
  put( "a - b = " ); put( a-b ); put(" <7/10> "); new_line;
  put( "b - a = " ); put( b-a ); put(" <-7/10> "); new_line;
  put( "a * b = " ); put( a*b ); put(" <1 1/5> "); new_line;
  put( "a / b = " ); put( a/b ); put(" <1 7/8> "); new_line;
end main2;

procedure main3 is
  a : Rational;
begin
  -- put( 8/16 ) is ambiguous;
  new_line;
  put( " 0, 0      = " ); a := rat_const(0, 0);   put( a ); new_line;
  put( " 0, 5      = " ); a := rat_const(0, 5);   put( a ); new_line;
  put( " 5, 0      = " ); a := rat_const(5, 0);   put( a ); new_line;
  put( " 8, 16     = " ); a := rat_const(8, 16);  put( a ); new_line;
  put( " 8, 8      = " ); a := rat_const(8, 8);   put( a ); new_line;
  put( " -17, 8    = " ); a := rat_const(-17, 8); put( a ); new_line;
  put( " -17, -8   = " ); a := rat_const(-17, -8);put( a ); new_line;
  put( " 17, -8    = " ); a := rat_const(17, -8); put( a ); new_line;
  put( " 7, 97     = " ); a := rat_const(7, 97);  put( a ); new_line;
  put( " 40, 20    = " ); a := rat_const(40, 20); put( a ); new_line;
  put( " 20, 40    = " ); a := rat_const(20, 40); put( a ); new_line;
  put( " 648, 972  = " ); a := rat_const(648,972);put( a ); new_line;
end main3;

procedure main4 is
  a : Rational;
begin
  a := rat_const(0, 0);
  for i in 1 .. 5 loop
    a := a + rat_const(1,i);
  end loop;
  put("Sum of 1/1 + 1/2 + ... 1/5 is "); put( a ); new_line;
end main4;

procedure main5 is
  a : Rational;
  UP_TO : CONSTANT := 7;
begin
  a := rat_const(1, 1);
  for i in 1 .. UP_TO loop
    a := a + rat_const(1, i);
  end loop;
  for i in reverse 1 .. UP_TO loop
    a := a - rat_const(1, i);
  end loop;
  put("Sum  check answer should be 1 <=> "); put( a ); new_line;
  a := rat_const(1);
  for i in 1 .. UP_TO loop
    a := a * rat_const(1, i);
  end loop;
  for i in reverse 1 .. UP_TO loop
    a := a / rat_const(1,i);
  end loop;
  put("Mult check answer should be 1 <=> "); put( a ); new_line;
end main5;

end Pack_procedures;
