-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io; use Simple_io;
package body Class_bounded_string is

  function to_bounded_string( str:in String )
    return Bounded_string is
  begin
    return (v_str=>(str'Length, str));
  end to_bounded_string;

  function to_string(the:in Bounded_string) return String is
  begin
    return the.v_str.chrs( 1 .. the.v_str.length );
  end to_string;

  function "&" ( f:in Bounded_string; s:in Bounded_string )
    return Bounded_string is
  begin
    return (v_str=>(f.v_str.chrs'Length + s.v_str.chrs'Length,
                    f.v_str.chrs & s.v_str.chrs));
  end "&";

  function "&" ( f:in Bounded_string; s:in String )
    return Bounded_string is
  begin
    return (v_str=>(f.v_str.chrs'Length + s'Length,
                    f.v_str.chrs & s ) );
  end "&";

  function "&" ( f:in String; s:in Bounded_string )
    return Bounded_string is
  begin
    return ( v_str=>(f'Length + s.v_str.chrs'Length,
                     f & s.v_str.chrs ) );
  end "&";

  function slice( the:in Bounded_string;
                  low:in Positive; high:in Natural)
    return String is
  begin
    if low <= high and then high <= the.v_str.length then
        return the.v_str.chrs( low .. high );
     end if;
     return "";
  end slice;

  function "="  ( f:in Bounded_string; s:in Bounded_string )
    return Boolean is
  begin
    return f.v_str.chrs = s.v_str.chrs;
  end "=";

  function ">"  ( f:in Bounded_string; s:in Bounded_string )
    return Boolean is
  begin
    return f.v_str.chrs > s.v_str.chrs;
  end ">";

  function ">=" ( f:in Bounded_string; s:in Bounded_string )
    return Boolean is
  begin
    return f.v_str.chrs >= s.v_str.chrs;
  end ">=";

  function "<"  ( f:in Bounded_string; s:in Bounded_string )
    return Boolean is
  begin
    return f.v_str.chrs < s.v_str.chrs;
  end "<";

  function "<=" ( f:in Bounded_string; s:in Bounded_string )
    return Boolean is
  begin
    return f.v_str.chrs <= s.v_str.chrs;
  end "<=";

end Class_bounded_string;
