-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

with Simple_io; use Simple_io;
package Class_bounded_string is
  type Bounded_string is private;

  function to_bounded_string(str:in String)
    return Bounded_string;

  function to_string(the:in Bounded_string) return String;

  function "&" (f:in Bounded_string; s:in Bounded_string)
    return Bounded_string;
  function "&" (f:in Bounded_string; s:in String)
    return Bounded_string;
  function "&" (f:in String; s:in Bounded_string)
    return Bounded_string;

  function slice( the:in Bounded_string;
                  low:in Positive; high:in Natural )
    return String;

  function "="  ( f:in Bounded_string; s:in Bounded_string )
    return Boolean;

  function ">"  ( f:in Bounded_string; s:in Bounded_string )
    return Boolean;
  function ">=" ( f:in Bounded_string; s:in Bounded_string )
    return Boolean;
  function "<"  ( f:in Bounded_string; s:in Bounded_string )
    return Boolean;
  function "<=" ( f:in Bounded_string; s:in Bounded_string )
    return Boolean;
private
  MAX_STRING: CONSTANT := 80;
  subtype Str_range is Natural range 0 .. MAX_STRING;
  type A_Bounded_string( length: Str_range := 0 ) is record
    chrs: String( 1 .. length );  -- Stored string
  end record;
  type Bounded_string is record
    v_str : A_Bounded_string;
  end record;
end Class_bounded_string;
