-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io, Class_bounded_string;
use  Simple_io, Class_bounded_string;
package body Class_container is

procedure main1 is
  town, county, address : Bounded_string;
begin
  town   := to_bounded_string( "Brighton" );
  county := to_bounded_string( "East Sussex" );

  address := town & " " & county;

  put( to_string(address) ); new_line;
  put( slice( county & " UK", 6, 14 ) );
  new_line;

end main1;

procedure main2 is
  text: Bounded_string;
  procedure check(b:in Boolean; str1,str2:in String) is
  begin
    if b then put(str1); else put(str2); end if;
    put(" ");
  end check;
begin
  put("=    /=   >    >=   >=   <    <=   <=    "); new_line;
  check(to_bounded_string("ABC") =  to_bounded_string("ABC") , "Pass",  "Fail");
  check(to_bounded_string("ABC") /= to_bounded_string("AB ") , "Pass",  "Fail");
  check(to_bounded_string("ABC") >  to_bounded_string("ABBB"), "Pass",  "Fail");
  check(to_bounded_string("ABC") >= to_bounded_string("ABBB"), "Pass",  "Fail");
  check(to_bounded_string("ABC") >= to_bounded_string("ABC") , "Pass",  "Fail");
  check(to_bounded_string("ABBB")<  to_bounded_string("ABC") , "Pass",  "Fail");
  check(to_bounded_string("ABBB")<= to_bounded_string("ABC") , "Pass",  "Fail");
  check(to_bounded_string("ABC") <= to_bounded_string("ABC") , "Pass",  "Fail");
  new_line;

  put("/=    =   <=   <    <    >=   >    >     "); new_line;
  check(to_bounded_string("ABC") /= to_bounded_string("ABC") , "Fail",  "Pass");
  check(to_bounded_string("ABC") =  to_bounded_string("AB ") , "Fail",  "Pass");
  check(to_bounded_string("ABC") <= to_bounded_string("ABBB"), "Fail",  "Pass");
  check(to_bounded_string("ABC") <  to_bounded_string("ABBB"), "Fail",  "Pass");
  check(to_bounded_string("ABC") <  to_bounded_string("ABC") , "Fail",  "Pass");
  check(to_bounded_string("ABBB")>= to_bounded_string("ABC") , "Fail",  "Pass");
  check(to_bounded_string("ABBB")>  to_bounded_string("ABC") , "Fail",  "Pass");
  check(to_bounded_string("ABC") >  to_bounded_string("ABC") , "Fail",  "Pass");
  new_line;

  put("Equality test"); new_line;
  for i in 1 .. 6 loop
    text := to_bounded_string("ABCDEFGH-ABCDEFGH");
    if slice(text,i,4) = slice(text,9+i,13) then
      put("Pass");
    else
      put("Fail");
    end if;
    put(" ");
  end loop;
  new_line;

end main2;

end Class_container;
