-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


--[main.adb] Procedure
WITH Simple_io, Class_stack_int;
USE  Simple_io, Class_stack_int;
PROCEDURE main IS
  number_stack : Stack;              -- Stack of numbers
  action       : Character;          -- Action
  number       : Integer;            -- Number processed
BEGIN
  reset( number_stack );             -- Reset stack to empty
  WHILE NOT end_of_file LOOP
    WHILE NOT end_of_line LOOP
      BEGIN
        get( action );
        CASE action IS               -- Process action
          WHEN '+' =>
            get( number ); push(number_stack,number);
            put("push number = "); put(number); new_line;
          WHEN '-' =>
            pop(number_stack,number);
            put("Pop number  = "); put(number); new_line;
          WHEN OTHERS =>
            put("Invalid action"); new_line;
        END CASE;
      EXCEPTION
        WHEN Stack_error =>
          put("Stack_error"); new_line;
        WHEN Data_error  =>
          put("Not a number"); new_line;
        WHEN End_error   =>
          put("Unexpected end of file"); new_line; EXIT;
      END;
    END LOOP;
    skip_Line;
  END LOOP;

  reset( number_stack );
END main;
