-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

--[class_stack.ads] Specification
WITH Text_io; USE Text_io;

GENERIC
  TYPE Stack_element IS PRIVATE;        --

PACKAGE Class_stack IS
  TYPE Stack IS LIMITED PRIVATE;        -- NO copying
  Stack_error : EXCEPTION;

  PROCEDURE push( the:IN OUT Stack; item:IN Stack_element );
  PROCEDURE pop(the:IN OUT Stack; item :OUT Stack_element );
  PROCEDURE reset( the:IN OUT Stack );
PRIVATE

  TYPE Node;                            -- Mutually recursive def
  TYPE P_Node IS ACCESS Node;           -- Pointer to a Node
  PRAGMA Controlled( P_node );          -- We do deallocation

  TYPE Node IS RECORD                   -- Node holds the data
    item   : Stack_element;             -- The stored item
    p_next : P_Node;                    -- Next in list
  END RECORD;

  TYPE Stack IS RECORD
    p_head : P_Node := NULL;            -- First node
  END RECORD;
END Class_stack;
