-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- Note I/O errors on finalize initialize passed to user
with B_string, Ada.Finalization; 
use  B_string, Ada.Finalization;
generic
  type Index is private;                  -- Index for record
  type Data  is private;                  -- Data for record
  with function  ">"( f:in Index; s:in Index ) return Boolean;
package Class_pic is
  Not_there, Exists, Per_error : exception; -- Raised Exceptions
  type PIC  is new Limited_controlled with private;
  procedure initialize( the:in out PIC );
  procedure initialize( the:in out PIC; id:in String );
  procedure finalize( the:in out PIC );
  procedure discard( the:in out PIC );
  procedure set_name( the:in out PIC; id:in String );
  function  get_name( the:in PIC ) return String;

  procedure add( the:in out PIC; i:in Index; d:in Data );
  procedure extract( the:in out PIC; i:in Index; d:in out Data );
  procedure update( the:in out PIC; i:in Index; d:in out Data );
private
  type Leaf;                     -- Index + Data
  type Subtree is access Leaf;   --
  type PIC is new Limited_controlled with record
    tree   : Subtree := null;    --  Storage
    obj_id : Bounded_string;     --  Name of object
  end record;

  function  find( the:in Subtree; i:in Index) return Subtree;
  procedure release_storage( the:in out Subtree );

end Class_pic;
