-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io, Pack_types, Class_tel_list;
use  Simple_io, Pack_types, Class_tel_list;
package body Pack_procedures is

procedure ex1 is
  tel_list : PIC;
begin
  put("Creating Telephone list"); new_line;
  set_name( tel_list, "tel_list.per" );
  add( tel_list, "Canada      ", "+1    " );
  add( tel_list, "USA         ", "+1    " );
  add( tel_list, "Netherlands ", "+31   " );
  add( tel_list, "Belgium     ", "+32   " );
  add( tel_list, "France      ", "+33   " );
  add( tel_list, "Gibraltar   ", "+350  " );
  add( tel_list, "Ireland     ", "+353  " );
  add( tel_list, "Switzerland ", "+41   " );
  add( tel_list, "UK          ", "+44   " );
  add( tel_list, "Denmark     ", "+45   " );
  add( tel_list, "Norway      ", "+47   " );
  add( tel_list, "Germany     ", "+49   " );
  add( tel_list, "Australia   ", "+61   " );
  add( tel_list, "Japan       ", "+81   " );
end ex1;

procedure ex2 is
  tel_list : PIC;
  action   : Character;
  name     : Country;
  tel      : IDC;
begin
  initialize( tel_list, "tel_list.per" );
  while not end_of_file loop
    begin
      get( action );                       -- Action to perform
      case action is
        when '+' =>                        -- Add
          get( name ); get( tel );
          add( tel_list, name, tel );
        when '=' =>                        -- Extract
          get( name );
          extract( tel_list, name, tel );
          put( "IDC for " ); put( name );
          put( " is "); put( tel ); new_line;
        when '*' =>                        -- Update
          get( name ); get( tel );
          update( tel_list, name, tel );
        when others =>                     -- Invalid action
          null;
      end case;
    exception
      when Not_there =>                    -- Not there
        put("Name not in directory"); new_line;
      when Exists =>                       -- Exists
        put("Name already in directory"); new_line;
    end;
    skip_line;
  end loop;
end ex2;

procedure ex3 is
  tel_list : PIC;
  name     : Country;
  tel      : IDC;
begin
  add( tel_list, "Canada      ", "+1    " );
  add( tel_list, "USA         ", "+1    " );
  add( tel_list, "Netherlands ", "+31   " );
  add( tel_list, "Belgium     ", "+32   " );
  add( tel_list, "France      ", "+33   " );
  add( tel_list, "Gibraltar   ", "+350  " );
  name := "France      ";
  extract( tel_list, name, tel );
  put( "IDC for " ); put( name ); put( " is "); put( tel ); new_line;
  name := "USA         ";
  extract( tel_list, name, tel );
  put( "IDC for " ); put( name ); put( " is "); put( tel ); new_line;
end ex3;

procedure ex4 is
  tel_list : PIC;
  name     : Country;
  tel      : IDC;
begin
  add( tel_list, "Canada      ", "+1    " );
  put("Object identity is ["); put( get_name(tel_list) ); put("]"); new_line;
  set_name( tel_list, "tel_list.per" );
  put("Object identity is ["); put( get_name(tel_list) ); put("]"); new_line;
  discard( tel_list );
end ex4;

end Pack_procedures;
