-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


--with Ada.Finalization; use  Ada.Finalization;
generic
package Class_list.Iterator is

  type List_iter is limited private;

  procedure initialize( the:in out List_iter );
  procedure finalize( the:in out List_iter );
  procedure first( the:in out List_iter; l:in out List );
  procedure last( the:in out List_iter; l:in out List );

  function  deliver( the:in List_iter) return T;
  procedure insert( the:in out List_iter; data:in T );
  procedure delete( the:in out List_iter );
  function  is_end( the:in List_iter ) return Boolean;
  procedure next( the:in out List_iter );
  procedure prev( the:in out List_iter );
private
  type P_P_Node is access all P_Node;
  type List_iter is record
    cur_list_first: P_P_Node := null;    -- First in chain
    cur_list_last : P_P_Node := null;    -- Last in chain
    cur_node      : P_Node   := null;    -- Current item
  end record;
end Class_list.Iterator;
