-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

-- list  -> ( first_node, last_node ) ( prev,item,next)
-- Iter  -> ( cur_list_first, cur_list_last, cur_node )

with Ada.Finalization, Unchecked_deallocation;
use  Ada.Finalization;
generic
  type T is private;                  -- Any type
package Class_list is
  type List is new Controlled with private;

  procedure initialize( the:in out List );
  procedure initialize( the:in out List; data:in T );
  procedure finalize( the:in out List );
  procedure adjust( the:in out List );
  function "="  ( f:in List; s:in List ) return Boolean;
private
  procedure release_storage( the:in out List );

  type Node;                       -- Tentative declaration
  type P_Node is access all Node;  -- Pointer to Node

  type Node is record
    prev    : P_Node;              -- Previous Node
    item    : T;                   -- The physical item
    next    : P_Node;              -- Next Node
  end record;

  procedure dispose_node is
    new unchecked_deallocation( Node, P_Node );
  type List is new Controlled with record
    first_node : aliased P_Node := null;   -- First item in list
    last_node  : aliased P_Node := null;   -- First item in list
  end record;

end Class_list;
