-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io; use Simple_io;
package body Class_set is
  use Class_list_t, Class_list_t_iterator;

  procedure put( the:in Set ) is
    it    : List_iter;
    c_the : List := List(the);
  begin
    put("("); first( it, c_the );
    for i in 1 .. the.elements loop
      put( deliver(it) ); next( it );
      if i /= the.elements then put(","); end if;
    end loop;
    put(")");
  end put;

  function "+"  ( f:in Set; s:in Set ) return Set is
    res_it    : List_iter;
    f_it,s_it : List_iter;
    res       : Set;
    f_list, s_list: List;
  begin
    f_list := List(f); s_list := List(s);
    first( f_it, List(f_list) );
    first( s_it, List(s_list) );
    first( res_it, List(res) );

    while (not is_end(f_it)) or (not is_end(s_it)) loop
      if is_end(f_it) then
        next(res_it); insert(res_it, deliver(s_it));
        next(s_it);
      elsif is_end(s_it) then
        next(res_it); insert(res_it, deliver(f_it));
        next(f_it);
      elsif deliver(f_it) < deliver(s_it) then
        next(res_it); insert(res_it, deliver(f_it));
        next(f_it);
      elsif deliver(f_it) > deliver(s_it) then
        next(res_it); insert(res_it, deliver(s_it));
        next(s_it);
      elsif deliver(f_it) = deliver(s_it) then
        next(res_it); insert(res_it, deliver(f_it) );
        next(f_it); next(s_it);
      end if;
      res.elements := res.elements + 1;
    end loop;
    return res;
  end "+";


  function set_const( item: in T ) return Set is
    res : Set;
  begin
    initialize( res, item ); res.elements := 1;
    return res;
  end set_const;

  function members( the:in Set ) return Positive is
  begin
    return the.elements;
  end members;

end Class_set;
