-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------



with Simple_io; use Simple_io;
with unchecked_deallocation;
package body Class_object_rc is

  procedure initialize( the:in out Object ) is
  begin
    build_storage( the, null_VALUE );
  end initialize;

  procedure initialize( the:in out Object; data:in T ) is
  begin
    build_storage( the, data );
  end initialize;

  procedure build_storage ( the:in out Object; value:in T ) is
  begin
    the.p_desc := new Descriptor'(1,value);
  end build_storage;

  procedure finalize( the:in out Object ) is
  begin
    if the.p_desc /= null then
      release_storage( the );
      the.p_desc := null;
    end if;
  end finalize;

  procedure dispose is
    new unchecked_deallocation( Descriptor, P_Descriptor );

  procedure release_storage( the:in out Object ) is
  begin
    the.p_desc.refs := the.p_desc.refs-1;
    if the.p_desc.refs = 0 then
      dispose( the.p_desc );
    else
      null;
    end if;
  end release_storage;

  procedure adjust( the:in out Object ) is
  begin
    the.p_desc.refs := the.p_desc.refs+1;
  end adjust;

  function  deliver( the:in Object) return T is
  begin
    return the.p_desc.object;
  end deliver;

  function  deliver_ref( the:in Object) return P_T is
  begin
    return the.p_desc.object'Access;
  end deliver_ref;

  procedure unique( the:in out Object) is
    tmp : P_Descriptor;
  begin
    if the.p_desc.refs > 1 then
      the.p_desc.refs := the.p_desc.refs-1;
      tmp := new Descriptor'(1,the.p_desc.object);
      the.p_desc := tmp;
    end if;
  end unique;
end Class_object_rc;
