-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- Generic in        constant
--         in out    Renaming

with Ada.Finalization; use Ada.Finalization;
generic
  type T is private;                    -- The type
  null_VALUE:in T;                      -- Identity element
package Class_object_rc is
  type Object is new Controlled with private;
  type P_T is access all T;

  procedure initialize( the:in out Object );
  procedure initialize( the:in out Object; data:in T );
  procedure finalize( the:in out Object );
  procedure adjust( the:in out Object );
  function  deliver( the:in Object) return T;
  function  deliver_ref( the:in Object) return P_T;
  procedure unique( the:in out Object);
private
  procedure build_storage ( the:in out Object; value:in T );
  procedure release_storage( the:in out Object );

  type Descriptor;
  type P_Descriptor is access all Descriptor;

  type Descriptor is record
    refs   : Natural;       -- References to this data
    object : aliased T;     -- The physical data
  end record;

  type Object is new Controlled with record
     p_desc : P_Descriptor:= null; -- Descriptor for a number
  end record;

end Class_object_rc;
