-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Pack_types;
use  Pack_types;
package Pack_threads is
  protected type PT_buffer is         -- Task type specification
    entry put( ch:in Character; no_more:in Boolean );
    entry get( ch:in out Character; no_more:out Boolean);
  private
    elements    : Queue_array;              -- Array of elements
    head        : Queue_index := 0;         -- Index
    tail        : Queue_index := 0;         -- Index
    no_in_queue : Queue_no    := 0;         -- Number in queue
    fin         : Boolean     := FALSE;     -- Finish;
  end PT_buffer;

  type P_PT_buffer is access all PT_buffer;

  task type Task_read(p_buffer:P_PT_buffer; fd_in:P_File_type) is
    entry finish;
  end Task_read;

  task type Task_write(p_buffer:P_PT_buffer; fd_out:P_File_type) is
    entry finish;
  end Task_write;
end Pack_threads;
