-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

with Ada.Text_io, Ada.Command_line;
use  Ada.Text_io, Ada.Command_line;
procedure main is
  fd  : Ada.Text_io.File_type;          -- File descriptor
  ch  : Character;                      -- Current character
begin
  if argument_count >= 1 then
    for i in 1 .. argument_count loop   -- Repeat for each file
      begin
        open( File=>fd, Mode=>IN_FILE,  -- Open file
              Name=>argument(i) );
        put("@@ "); put( argument(i) );
        put(" @@"); new_line;
        while not end_of_file(fd) loop  -- For each Line
          put("+");                     -- Marker
          while not end_of_line(fd) loop-- For each character
            get(fd,ch); put(ch);        -- Read / Write character
          end loop;
          skip_line(fd); new_line;      -- Next line / new line
        end loop;
        close(fd);                      -- Close file
      exception
        when Name_error =>
          put("arch: " & argument(i) & " no such file" );
          new_line;
        when Status_error =>
          put("arch: " & argument(i) & " all ready open" );
          new_line;
      end;
    end loop;
  else
    put("Usage: arch file1 ... "); new_line;
  end if;
end main;
