-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


----------------------------------------------------------------------

with Ada.Finalization, Pack_constants, Class_line, Class_store;
use  Ada.Finalization, Pack_constants, Class_line, Class_store;
package Class_display is

  type Mode    is ( NO_ECHO, ECHO );
  type Display is new Limited_Controlled with private;

  procedure debug( the:in Display );
  procedure initialize( the:in out Display );
  procedure finalize( the:in out Display );
  procedure clear( the:in out Display );

  procedure init( the:in out Display; s:in Store);
  procedure refresh( the:in out Display );

  procedure add( the:in out Display; b:in Store; ch:in Character );
  procedure del( the:in out Display; s:in Store );
  procedure position( the:in out Display; s:in Store );

  procedure status( the:in out Display; s:in Store );
  function  deliver_display_size( the:in Display ) return Natural;

private
  DisPLAY_LINES : CONSTANT := LINES_ON_SCREEN-1;
  type    Display_index is new Integer   range 0..DisPLAY_LINES;
  subtype Display_range is Display_index range 1..DisPLAY_LINES;

  procedure display_line( the:in out Display; i:in Display_index );
  procedure minimal_refresh( the:in out Display;
                             old_abs_line:in Natural );

  type Display_as_array is array ( Display_range ) of Line;
  type Display is new Limited_Controlled with record
     display       : Display_as_array;    -- Display
     no_lines      : Display_index := 0;  -- Active lines
     abs_line      : Natural := 0;        -- of 1st display line
     row           : Natural := 0;        -- current row
     col           : Natural := 0;        -- current column
  end record;

end Class_display;
