-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


----------------------------------------------------------------------

with Ada.Finalization, Class_store, Pack_constants, Class_user, Class_display;
use  Ada.Finalization, Class_store, Pack_constants, Class_user, Class_display;
package Class_file is

  type File is new Limited_Controlled with private;

  procedure initialize( the:in out File );
  procedure finalize( the:in out File );
  procedure register( the:in out File; str:in String );
  function  is_active( the:in File ) return Boolean;
  procedure set_active( the:in out File );
  procedure set_not_active( the:in out File );
  procedure read ( the:in out File; s:in out Store );
  procedure write( the:in out File; s:in out Store; u:in User );

private
  type    File_index  is range 0 .. MAX_ANSWER;
  subtype File_range  is File_index  range 1 .. MAX_ANSWER;
  type    State_file  is ( ACTIVE, not_ACTIVE );
  type File is new Limited_Controlled with record
    state         : State_file := not_ACTIVE;
    lines_in_file : Natural := 0;
    file          : String( 1 .. MAX_ANSWER );
    file_length   : File_index := 0;
  end record;
end Class_file;
