-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


----------------------------------------------------------------------

with Ada.Finalization;
use  Ada.Finalization;
package Class_line is
  type Line is new Controlled with private;

  procedure debug( the:in Line );
  procedure initialize( the:in out Line );
  procedure finalize( the:in out Line );
  procedure adjust( the:in out Line );
  procedure clear( the:in out Line );

  procedure start( the:in out Line );       -- Iterator for line
  function  end_of_line( the:in Line) return Boolean;
  function  get_char( the:in Line ) return Character;
  procedure next_ch( the:in out Line );

  procedure add(the:in out Line; where:in Natural; ch:in Character);
  procedure del( the:in out Line; where:in Natural );

  function  deliver_current_col( the:in Line ) return Natural;
  function  deliver_cur_len( the:in Line ) return Natural;
  function  deliver_max_line_size( the:in Line ) return Natural;

private
  MAX_CHS : CONSTANT := 79;
  type    Line_iter_index is range 0 .. MAX_CHS+1;
  subtype Line_index      is Line_iter_index range 0 .. MAX_CHS;
  subtype Line_range      is Line_iter_index range 1 .. MAX_CHS;
  type    Line_array      is array ( Line_range ) of Character;

  --type O_Line is record
  type Line is new Controlled with record
     chs        : Line_array;          -- Line of characters
     iter_pos   : Line_iter_index := 0;-- Iterator position
     cur_len    : Line_index := 0;     -- Position of last ch
     col        : Line_range := 1;     -- Last operation here
  end record;
  --type Line is access O_Line;          -- Pointer to a Line

end Class_line;
