-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Pack_md_io;
use  Pack_md_io;
package body Pack_ansi_display is
  PREFIX: CONSTANT String := Character'Val(27) & "[";

  procedure clear is                      -- Clear screen
  begin
    put( PREFIX & "2J");
  end clear;

  procedure down( n:in Natural ) is      -- Cursor Down
  begin
    put( PREFIX ); put( n );put("B");
  end down;

  procedure up( n:in Natural ) is        -- Cursor Up
  begin
    put( PREFIX ); put( n );put("A");
  end up;

  procedure left( n:in Natural ) is      -- Cursor Left
  begin
    put( PREFIX ); put( n );put("D");
  end left;

  procedure right( n:in Natural ) is      -- Cursor Right
  begin
    put( PREFIX ); put( n );put("C");
  end right;

  procedure insert_line( n:in Natural ) is
  begin
    put( PREFIX ); put( n ); put("L");
  end insert_line;

  procedure delete_line( n:in Natural ) is
  begin
    put( PREFIX ); put( n ); put("M");
  end delete_line;

  procedure cursor_position(row:in Natural; column:in Natural) is
  begin
    put( PREFIX ); put(row); put(";"); put(column); put("H");
  end cursor_position;

  procedure clear_to_end_of_line is    -- Clear to end of line
  begin
    put( PREFIX & "K");
  end clear_to_end_of_line;

  procedure put( n:in Natural ) is     -- Write decimal number
  begin
    if n >= 10 then put( n / 10 ); end if;
    put( Character'Val(n rem 10 + Character'Pos('0') ) );
  end put;

end Pack_ansi_display;
