-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

-- The editor
--   To compile using the GNAT Ada 95 Compiler on Windows 95/NT, Linux
-- 
--   gnatchop -w x80_ed.ada          -- Split into units
--   gcc -c io.c                     -- Compile C interface
--   gnatmake ed.adb -largs io.o     -- Compile program
-- 
-- Notes:
--   The file io.c is the commented out C code before Raw_io.adb
--   The current I/O system with Windows 95 can not cope with 
--     the fast reception of characters
--   ^C Will Kill the program use ^E to exit
--   ^D Will cause the program to terminate do not use
-- 
--   In the package Pack_constants
--     ANSI_IN_DEL currently must be set to FALSE for Windows 95/NT
--     as the ANSI escape sequences for Insert and Delete lines are
--     not supported.
--     Using this setting will slow down the refreshing of the screen.


package Pack_constants is
  MAX_ANSWER     : CONSTANT := 80;
  LINES_ON_SCREEN: CONSTANT := 25;
  PAGE_RACK      : CONSTANT := LINES_ON_SCREEN/2;

  C_LEFT         : CONSTANT Character := Character'Val(012);
  C_RIGHT        : CONSTANT Character := Character'Val(018);
  C_UP           : CONSTANT Character := Character'Val(021);
  C_DOWN         : CONSTANT Character := Character'Val(011);

  C_PAGE_UP      : CONSTANT Character := Character'Val(023);
  C_PAGE_DOWN    : CONSTANT Character := Character'Val(024);

  C_QUIT         : CONSTANT Character := Character'Val(005);
  C_DEBUG        : CONSTANT Character := Character'Val(020);
  C_REFRESH      : CONSTANT Character := Character'Val(025);
  C_DEL          : CONSTANT Character := Character'Val(008);

  C_OPEN         : CONSTANT Character := Character'Val(001);
  C_CLOSE        : CONSTANT Character := Character'Val(002);
  C_SET_FN       : CONSTANT Character := Character'Val(006);

  C_NEXT         : CONSTANT Character := Character'Val(007);

  ANSI_INS_DEL   : CONSTANT Boolean   := FALSE;
end Pack_constants;
