-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

      
    
with Ada.Text_io, Ada.Command_line, Class_line; -- **** FIXED
use  Ada.Text_io, Ada.Command_line, Class_line;
procedure main is
  i_fd   : Ada.Text_io.File_type;        -- File descriptor
  o_fd   : Ada.Text_io.File_type;        -- File descriptor
  a_line : Class_line.Line;
begin
  if argument_count >= 1 then
    for i in 1 .. argument_count loop    -- Repeat for each file
      begin
        open( File=>i_fd, Mode=>IN_FILE, -- Open file
              Name=>argument(i) );
        while not end_of_file(i_fd) loop -- For each Line
          get_line( a_line, i_fd );
          case status(a_line) is
            when TEXT_LINE =>            -- Write to file
              put_line( a_line, o_fd );
            when FILE_NAME =>            -- Get file name
              get_fd( a_line, o_fd );    
            when UNKNOWN =>              -- Ignore
              null;
          end case;
        end loop;
        close(i_fd);                     -- Close file
      exception
        when Name_error =>
          put("Exp: " & argument(i) & " no such file" );
          new_line;
        when Status_error =>
          put("Exp: " & argument(i) & " all ready open" );
          new_line;
        when others =>
          put("Exp: " & argument(i) & " unknow error" );
          new_line;
      end;
    end loop;
  else
    put("Usage: Exp file1 ... "); new_line;
  end if;
end main;
