-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------

with Ada.Text_io;   -- **** FIXED
use  Ada.Text_io;   -- **** FIXED
package Class_line is
  type Line_status is ( TEXT_LINE, FILE_NAME, UNKNOWN );
  type Line is private;
  procedure get_line( the:in out Line; fd:in Ada.Text_io.File_type );
  procedure put_line( the:in Line; fd:in Ada.Text_io.File_type );
  procedure get_fd( the:in out Line; fd:in out Ada.Text_io.File_type );
  function  status( the:in Line ) return Line_status;
private
  MAX_LINE : CONSTANT := 200;
  subtype Line_index is Integer range 0 .. MAX_LINE+1;
  subtype Line_range is Line_index range 1 .. MAX_LINE;
  subtype Line_array is String( Line_range );
  type Line is record
    chs : Line_array;       -- Characters of line
    len : Line_index;       -- Positions used
    open: Boolean := FALSE; -- Output file open
  end record;
  name     : Line_array;    -- File name from file
  name_pos : Line_index;    -- Characters in name
end Class_line;
