-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


----------------------------------------------------------------------

with Class_board, Class_player, Class_counter;
use  Class_board, Class_player, Class_counter;
procedure play is                            -- Reversi
  reversi       : Board;                     -- The playing board
  contestant    : array(Counter_colour) of Player;
  current_state : State_of_game;             -- State of game
  person        : Counter_colour;            -- Current player
  x, y          : Integer;                   -- Move
  move_is       : Move_status;               -- Last move is
begin
  set_up( reversi );                         -- Set up board
  set( contestant(BLACK), BLACK );           -- Set player black
  set( contestant(WHITE), WHITE );           -- Set player white

  current_state := PLAY;  person := BLACK;   -- Black starts

  display( reversi );                        -- Initial board

  while current_state = PLAY loop            -- Playable game
    now_playing( reversi, person );          -- set player

    loop                                     -- Get move
      get_move( contestant(person), x, y );
      move_is := check_move(reversi, x, y);  -- Validate
      exit when move_is=OK or move_is=PASS;  -- OK
    end loop;

    add( reversi, x, y, move_is );           -- Add move to board

    display( reversi );                      -- Display new board
    current_state := status( reversi );      -- State of play is

    if current_state = PLAY then             -- Is still playable
      case person is                         -- next player
        when BLACK  => person := WHITE;
        when WHITE  => person := BLACK;
      end case;
    end if;

  end loop;                                   -- Next move

  announce( contestant(person), current_state );  -- Result

end play;
