-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


package body Class_cell is
  procedure initialize( the:in out Cell ) is
  begin
    the.contents := EMPTY_CELL;   -- Initialize cell to empty
  end initialize;

  function  holds( the:in Cell ) return Cell_holds is
  begin
    case the.contents is
      when EMPTY_CELL     =>             -- Empty
        return EMPTY;                    --  No counter
      when not_EMPTY_CELL =>             -- Counter
        case rep( the.item ) is
          when WHITE => return C_WHITE;  --  white counter
          when BLACK => return C_BLACK;  --  black counter
        end case;
    end case;
  end holds;

  procedure add(the:in out Cell; players_counter:in Counter) is
  begin
    the := (not_EMPTY_CELL,players_counter);
  end add;

  procedure display( the:in Cell ) is
  begin
    if the.contents = not_EMPTY_CELL then
      display( the.item );           -- Display the counter
    else
      display_none( the.item );      -- No counter
    end if;
  end display;

  procedure flip( the:in out Cell ) is
  begin
    flip( the.item );                -- Flip counter
  end flip;

  function to_colour(c:in Cell_holds) return Counter_colour is
  begin
    case c is                        -- Conversion of enum.
      when C_WHITE => return WHITE;
      when C_BLACK => return BLACK;
      when others  => raise Constraint_error;
    end case;
  end to_colour;

end Class_cell;
