-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


----------------------------------------------------------------------

with Class_counter;
use  Class_counter;
package Class_cell is
  type Cell is private;
  type Cell_holds is ( C_WHITE, C_BLACK, EMPTY );

  procedure initialize( the:in out Cell );
  function  holds( the:in Cell ) return Cell_holds;
  procedure add( the:in out Cell; players_counter:in Counter );
  procedure display( the:in Cell );
  procedure flip( the:in out Cell );
  function to_colour( c:in Cell_holds ) return Counter_colour;
private
  type Cell_is is ( EMPTY_CELL, not_EMPTY_CELL );
  type Cell is record
    contents: Cell_is := EMPTY_CELL;
    item    : Counter;                 -- The counter
  end record;
end Class_cell;
