-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Simple_io;
use  Simple_io;
package body Class_player is
  procedure set(the:in out Player; c:in Counter_colour ) is
    a_counter : Counter;
  begin
    set( a_counter, c );          -- Set colour
    the.plays_with := a_counter;  -- Player is playing with
  end set;

  procedure get_move(the:in Player; row,column:out Integer) is
    valid_move : Boolean := FALSE;
  begin
    while not valid_move loop
      begin
        put("Please enter move "); display( the.plays_with );
        put(" row column : "); get( row ); get( column );
        valid_move := TRUE;
      exception
        when Data_Error =>
          row := -1; column := -1; skip_line;
        when End_error =>
          row := 0; column := 0;
          return;
      end;
    end loop;
  end get_move;

  function  my_counter( the:in Player ) return Counter is
  begin
    return the.plays_with;
  end my_counter;

  procedure announce(the:in Player; what:in State_of_game) is
  begin
    case what is
      when Win    =>
        put("Player "); display( the.plays_with );
        put(" has won");
      when LOSE   =>
        put("Player "); display( the.plays_with );
        put(" has lost");
      when DRAW   =>
        put("It's a draw");
      when others =>
        raise Constraint_error;
    end case;
    new_line;
  end announce;

end Class_player;
