-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


-- === === === === === === === === === === === === === ===

--package Class_room.build is
--  type P_Room is access all Room'Class;
--
--  function  build_room( no:in Positive;
--                        desc:in String ) return P_Room;
--end Class_room.build;
--
--package body Class_room.build is
--
--  function  build_room( no:in Positive;
--                        desc:in String ) return P_Room is
--    p : P_Room;
--  begin
--    p := new Room; initialize( p.all, no, desc );
--    return p;
--  end build_room;
--
--end Class_room.build;

-- === === === === === === === === === === === === === ===

--with Class_room, Class_room.build;
--use  Class_room, Class_room.build;
--package Class_office.build is
--
--  function  build_office( no:in Positive; desc:in String;
--                          people:in Natural ) return P_Room;
--end Class_office.build;
--
--
--package body Class_office.build is
--
--  type P_Office is access all Office;
--
--  function  build_office( no:in Positive; desc:in String;
--                          people:in Natural ) return P_Room is
--    p : P_Office;
--  begin
--    p := new Office; initialize( p.all, no, desc, people );
--    return p.all'Access;
--  end build_office;
--
--end Class_office.build;

-- === === === === === === === === === === === === === ===

--with Ada.Text_io, Class_room, Class_room.build;
--use  Ada.Text_io, Class_room, Class_room.build;
with Ada.Text_io, Class_abstract_room;
use  Ada.Text_io, Class_abstract_room;
package Class_building is

  type Building is tagged private;

  procedure add( the:in out Building; desc:in P_A_Room );
  function about(the:in Building; no:in Positive) return String;

private
  MAX_ROOMS : CONSTANT := 15;
  type    Rooms_index is range 0 .. MAX_ROOMS;
  subtype Rooms_range is Rooms_index range 1 .. MAX_ROOMS;
  type    Rooms_array is array (Rooms_range) of P_A_Room;

  type Building is tagged record
    last        : Rooms_index := 0;  -- Last slot allocated
    description : Rooms_array;       -- Rooms in building
  end record;
end Class_building;
