-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


with Ada.Integer_Text_io;
use  Ada.Integer_Text_io;
package body Class_room is

  procedure initialize( the:in out Room;
                        no:in Positive; mes:in String ) is
  begin
    the.desc := to_unbounded_string( mes );
    the.number := no;
  end initialize;

  function  build_room( no:in Positive;
                        desc:in String ) return P_A_Room is
    p : P_Room;
  begin
    p := new Room; initialize( p.all, no, desc );
    return p.all'Access;
  end build_room;

  function  where( the:in Room ) return Positive is
  begin
    return the.number;
  end where;

  function  describe( the:in Room ) return String is
    num : String( 1 .. 4 );    -- Room number as string
  begin
    put( num, the.number );
    return num & " " & to_string(the.desc);
  end describe;

end Class_room;
