-------------------------------------------------------------
-- (C) Michael A Smith 1993-1997                           --
-- Taken from the book Object-oriented software in Ada 95  --
--  Published by International Thomson Publishing          --
--     See http://www.brighton.ac.uk/ada95/home.htm       --
-------------------------------------------------------------


--with Ada.Integer_Text_io, Ada.Text_io,
--     Class_room, Class_room.build,
--     Class_office, Class_office.build, Class_building, Ada.Tags;
--use  Ada.Integer_Text_io, Ada.Text_io,
--     Class_room, Class_room.build,
--     Class_office, Class_office.build, Class_building, Ada.Tags;
with Ada.Integer_Text_io, Ada.Text_io,
     Class_abstract_room, Class_room, Class_office, Class_building, Ada.Tags;
use  Ada.Integer_Text_io, Ada.Text_io,
     Class_abstract_room, Class_room, Class_office, Class_building, Ada.Tags;
package body Pack_procedures is

procedure ex1 is
  w422 : Room;
  w414 : Office;
  procedure about( place:in Room'Class ) is
  begin
    put( "The place is" ); new_line;
    put( "  " & describe( place ) ) ;  -- Run time dispatch
    new_line;
  end about;
begin
  initialize( w414, 414, "4th Floor west wing", 2 );
  initialize( w422, 422, "4th Floor east wing" );

  about( w422 );                       -- Call with a room
  about( w414 );                       -- Call with an Office

end ex1;

procedure ex2 is
  w422: Room;
  w414: Office;
begin
  initialize( w414, 414, "4th Floor west wing", 2 );
  initialize( w422, 422, "4th Floor east wing" );

  --if w422'Tag = w414'Tag then
  if FALSE then
    put("Areas are the same type of accommodation");
    new_line;
  end if;
  --if w422'Tag /= w414'Tag then
  if TRUE then
    put("Areas are different type of accommodation");
    new_line;
  end if;
end ex2;

procedure ex3 is

procedure set_up( watts:in out Building ) is
begin
  add( watts, build_office( 414, "4th Floor west wing", 2 ) );
  add( watts, build_room  ( 422, "4th Floor east wing" ) );
end set_up;

procedure main is
  watts   : Building;                      -- Watts Building
  room_no : Positive;                      -- Queried room
begin
  set_up( watts );                         -- Populate building
  loop
    begin
      put( "Inquiry about room: " );       -- Ask
      exit when end_of_file;
      get( room_no ); skip_line;           -- User response
      put( about( watts, room_no ) );
      new_line;                            -- Display answer
    exception
      when Data_error =>
        put("Please retype the number");   -- Ask again
        new_line; skip_line;
    end;
  end loop;
end main;

begin
  main;
end ex3;

procedure ex4 is
begin
  null;
end ex4;

-- Downcasting

procedure ex5 is
  MAX_ROOMS : CONSTANT := 3;
  type    Rooms_index  is range 0 .. MAX_ROOMS;
  subtype Rooms_range  is Rooms_index range 1 .. MAX_ROOMS;
  type    Rooms_array  is array ( Rooms_range ) of P_A_Room;
  type    Office_array is array ( Rooms_range ) of Office;
  accommodation : Rooms_array;    -- Rooms and Offices
  offices       : Office_array;   -- Offices only
  no_offices    : Rooms_index;
begin
  accommodation(1):=build_office(414, "4th Floor west wing", 2);
  accommodation(2):=build_room  (518, "5th Floor east wing");
  accommodation(3):=build_office(403, "4th Floor east wing", 1);

  no_offices := 0;
  for i in Rooms_range loop
    if accommodation(i).all'Tag = Office'Tag then
      no_offices := no_offices + 1;
      offices(no_offices) := Office(accommodation(i).all);  --
    end if;
  end loop;

  put("The offices are:" ); new_line;
  for i in 1 .. no_offices loop
    put( describe( offices(i) ) ); new_line;
  end loop;

end ex5;

procedure ex6 is
  --MAX_ROOMS : CONSTANT := 2;
  --type P_Room is access all Room'Class;
  w422 : aliased Room;
  w414 : aliased Office;
begin
  return;
  initialize( w422, 422, "4th Floor east wing" );
  initialize( w414, 414, "4th Floor west wing", 2 );
  --put( Ada.Tags.external_tag( w422'Tag ) ); new_line;
  --put( Ada.Tags.expanded_name( w422'Tag ) ); new_line;
end ex6;

procedure ex7 is
  MAX_ROOMS : CONSTANT := 3;
  type    Rooms_index is range 0 .. MAX_ROOMS;
  subtype Rooms_range is Rooms_index range 1 .. MAX_ROOMS;
  type    Rooms_array is array ( Rooms_range ) of P_A_Room;
  accommodation : Rooms_array;
begin
  accommodation(1):=build_office(414, "4th Floor west wing", 2);
  accommodation(2):=build_room  (518, "5th Floor east wing");
  accommodation(3):=build_office(403, "4th Floor east wing", 1);
end ex7;

-- If only one componant in a record aggrigate then must be named
-- If more than one componant WITH
--  withdraws => 2, xx => 3 etc.

procedure ex8 is
  WITHDRAWALS_IN_A_WEEK : CONSTANT Natural := 3;
  subtype Money    is Float;
  type Account     is tagged record
     balance_of : Money := 0.00;      -- Amount in account
  end record;
  type Account_ltd is new Account with record
    withdrawals : Natural := WITHDRAWALS_IN_A_WEEK;
  end record;
  type Account_2 is new Account with null record;
  normal     : Account;
  restricted : Account_ltd;
  other      : Account_2;
begin
  normal     := ( balance_of => 20.0 );
  restricted := ( normal with 4 );
  restricted := ( normal with withdrawals => 4 );
  other      := ( normal with null record );
end ex8;

end Pack_procedures;
